public class CategoryGroup{
float epsilon=0.001;
 public HashMap<Integer, CategoryItem> myItems;
 public int selectedItem;
float graphSize;

 CategoryGroup(int numItems, float gsize){
   myItems = new HashMap<Integer, CategoryItem>(numItems);
   selectedItem=-1;
   this.graphSize = gsize;
 }
 public void addItem(int x, CategoryItem i){
   myItems.put(x, i);
}
public CategoryItem  getLegendItem(int id){
  return myItems.get(id);
}
public boolean checkSelected(){
  boolean answer=false;
    for (CategoryItem item: this.myItems.values()){
      if(item.checkDist()){
        answer=true;
      this.selectedItem = item.id;
      }
      }
      return answer;
}

void display(){
 pushStyle();  
 int l=0;
 for(float theta=0;theta<2*PI*(1-epsilon);theta+=2*PI/myItems.size()){
   float x=graphSize*(1.05)*cos(theta);
   float y=graphSize*(1.05)*sin(theta);
   CategoryItem nextItem = myItems.get(l);
   if(l==selectedItem) nextItem.selected=true;
   else nextItem.selected=false;
   nextItem.display(x,y);
   l++;
  }
}
}

class CategoryItem{
  Series mySeries;
  color myColor;
  boolean selected=false;
  float xCoord,yCoord;
  int id;
  
  CategoryItem(Series series, color c,int id){
    mySeries= series;
    myColor = c;
    this.id=id;
  }
  
  void display(float x, float y){
    pushStyle();
    xCoord=x;
    yCoord=y;
    fill(myColor);
      if (selected){
             stroke(360);
             strokeWeight(1.5);}
       else{stroke(120);}
    ellipse(x,y,20,20);
    popStyle();
  }
  
 boolean checkDist(){
    return (dist(xCoord+2*width/3,yCoord+height/2,mouseX, mouseY)<20/2);
  }
  
  void changeState(){
  selected=!selected;
  //this.mySeries.changeState();
  }
  
}

